﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DateTimeAxisMinMax
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = this;
            DataGenerator viewModel = new DataGenerator();
            ObservableCollection<Data> collection = viewModel.GenerateData();
            Series1.ItemsSource = collection;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var source = Series1.ItemsSource as ObservableCollection<Data>;
            axis.Minimum = source[source.Count - 1].Date;
            axis.Maximum = source[0].Date;
        }
    }

    public class DataGenerator
    {
        public int DataCount = 10000;

        private Random randomNumber;

        public DataGenerator()
        {
            randomNumber = new Random();
        }

        public ObservableCollection<Data> GenerateData()
        {
            ObservableCollection<Data> datas = new ObservableCollection<Data>();
            DateTime date = new DateTime(2001, 1, 1);
            double value = 1000;
            for (int i = 0; i < this.DataCount; i++)
            {
                datas.Add(new Data(date, value));
                date = date.AddDays(1);

                if (randomNumber.NextDouble() > .5)
                {
                    value += randomNumber.NextDouble();
                }
                else
                {
                    value -= randomNumber.NextDouble();
                }
            }

            return datas;
        }
    }

    public class Data
    {
        public Data(DateTime date, double value)
        {
            Date = date;
            Value = value;
        }

        public DateTime Date
        {
            get;
            set;
        }

        public double Value
        {
            get;
            set;
        }

    }
}
